const path = require('path');
const os = require('os');
const fs = require('fs');
const cprocess = require('child_process');
const interfaces = os.networkInterfaces();
/**
 * 默认读取根目录下的favicon.ico文件
 */
const getFavico = function () {
  const faviconPath = path.resolve(process.cwd(), 'favicon.ico');
  if (fs.existsSync(faviconPath)) {
    return faviconPath;
  }
  return '';
};
const getAppName = function () {
  const {
    name
  } = path.parse(process.cwd());
  return name;
};

const getIpAddress = function () {
  let IPAdress = '';
  for (var devName in interfaces) {
    var iface = interfaces[devName];
    for (let i = 0; i < iface.length; i++) {
      var alias = iface[i];
      if (alias.family === 'IPv4' && alias.address !== '127.0.0.1' && !alias.internal) {
        IPAdress = alias.address;
      }
    }
  }
  return IPAdress;
};
const openBrower = function (url) {
  cprocess.exec(`start ${url}`);
};

//获取用户自定义配置
const getCustomConfig = () => {
  let config = {}
  if (fs.existsSync(path.resolve(process.cwd(), 'n.config.js'))) {
    config = require(path.resolve(process.cwd(), 'n.config.js'));
  }
  return config
}

/**
 * 判断用户项目根目录下是否有tsConifg文件
 */
const getTsconfig = () => {
  return fs.existsSync(path.resolve(process.cwd(), 'tsconfig.json'))
}
/** 
 * 获取html模板文件
 */
const getTtmlTempalte = () => {
  if (fs.existsSync(path.resolve(process.cwd(), 'index.html'))) {
    return path.join(process.cwd(), './index.html');
  }
  return path.join(__dirname, './index.html')


}

module.exports = {
  getFavico,
  getAppName,
  getIpAddress,
  openBrower,
  getCustomConfig,
  getTsconfig,
  getTtmlTempalte
};
